--------
EINGABE:
--------

<h1>TvsGB - Gästebuch</h1>


--------
AUSGABE:
--------

<?php

	global $REX;
	$mypage = "tvsgb";
	
	if (OOAddon::isAvailable($mypage)) {
		$table_pre = "rex_".$REX['ADDON']['rxid'][$mypage];
		$art_table = $table_pre . "_entries";

		$myIniFile = $REX['INCLUDE_PATH'] . "/addons/" . $mypage . "/" . $mypage . ".ini";

		if (file_exists($myIniFile)) {
			$stringData = file_get_contents($myIniFile);
			$settings = parse_ini_file($myIniFile);
		}

		if($REX['REDAXO'] != 1) {

			$infomail		= $settings['info_mail'];
			$frommail		= $settings['from_mail'];
			$highlightpw	= $settings['highlight_pw'];
			$max_entries	= $settings['max_entries'];
			$confirmstring	= $settings['confirmstring'];
			$allowreplies	= $settings['allow_replies'];
			$usesmilies		= $settings['usesmilies'];
			
			if ($settings['lock_gb'] == 1) {
				$sperren		= true;
			} else {
				$sperren		= false;
			};

		
			$id = rex_get('tvsgb_id', 'int', 0);
			$mode = rex_get('mode', 'string', '');
			$name = rex_post('name', 'string', '');
			$email = rex_post('email', 'string', '');
			$web = rex_post('web', 'string', '');
			$eintrag = rex_post('eintrag', 'string', '');
			$ergebnis = rex_post('ergebnis', 'string', '');

			// *******
			// Main...
			// *******

			$output = "<div id=\"gbook\">";
			//
			// Speichern neuer Eintrag...
			//

			if ($mode == "put")
			{
				if (strtoupper($ergebnis) == strtoupper($confirmstring)) {

					$sql = new rex_sql();
					$sql->setQuery("INSERT INTO " . $art_table . " (create_user, email, web, description, clang, status, create_date) VALUES ('" . $name . "', '" . $email . "', '" . $web . "', '" . $eintrag . "', 0, 1, " . time() . ")");

					// Infomail senden
					if ($infomail != "")
					{
	//					$destheader = "MIME-Version: 1.0\r\nFrom:" . $frommail;
	//					mail($infomail, "Neuer Gästebucheintrag am " . date("d.m.Y H:i:s"), "$email\n$web\n$eintrag\n" . date("d.m.Y H:i:s") . "\n", $destheader, "-f" . $frommail);
						$destsubject = "Neuer Gästebucheintrag am " . date("d.m.Y H:i:s");
						$destbody = "$email\n$web\n$eintrag\n" . date("d.m.Y H:i:s");
						$mail = new rex_mailer();
						$mail->Sender = $frommail;
						$mail->From = $frommail;
						$mail->FromName = $frommail;
						$mail->AddAddress($infomail);
						$mail->Subject = utf8_decode($destsubject);
						$mail->Body = utf8_decode($destbody);
						$mail->Send();
					}
				}

				$output .= "<body onLoad=\"javascript:window.location.href='" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . "';\">";
			}
			
			//
			// Zeigen des Gästebuchs...
			//
			if ($max_entries != 0)
			{
				if ($mode == "view" || $mode == "")
				{

					if (!isset($tvsgb_start))
						$tvsgb_start = 0;

					if (rex_get('tvsgb_start', 'int', 0) != 0) {
						$tvsgb_start = rex_get('tvsgb_start', 'int', 0);
						$tvsgb_limit = $max_entries;
					}
					else
						if ($max_entries == "") {
							$tvsgb_start = 0;
							$tvsgb_limit = 99;
						}
						else {
							$tvsgb_start = 0;
							$tvsgb_limit = $max_entries;
						}
					$sql_limit = " LIMIT " . $tvsgb_start . ", " . $tvsgb_limit;

					$sql = new rex_sql();
					$sql->setQuery("SELECT * FROM " . $art_table . " WHERE status = 1 ORDER BY create_date DESC");
					$total_rows = $sql->getRows();

					if ($sperren == false) {
						$output .= "<input type=\"button\" value=\"Neuer Eintrag\" onClick=\"window.location.href='" . rex_getUrl('','', array('mode'=>'add'), '&amp;') . "';\" /><br /><p>&nbsp;</p>\n";
					}
					
					$sql->setQuery("SELECT * FROM " . $art_table . " WHERE status = 1 ORDER BY create_date DESC" . $sql_limit);
					$current_rows = $sql->getRows();
					if ($current_rows > 0 ) {
						for ($i = 1; $i <= $current_rows; $i++) {
							if ($sql->getValue('email') == $highlightpw)
								$output .= "<div class=\"gb-highlight\">";
							else
								$output .= "<div class=\"gb-entry\">";
							$output .= "	<div class=\"gb-nr\">" . $sql->getValue('id') . "</div><div class=\"gb-top\">";
							if ($sql->getValue('web') != "") {
								$output .= "<a href=\"";
								if (substr($sql->getValue('web'),7) != "http://")
									$output .= "http://";
								$output .= $sql->getValue('web') . "\" target=\"_blank\">";
							}
							$createuser = $sql->getValue('create_user');
							$createuser = str_replace ("Ã„", "&Auml;", $createuser);
							$createuser = str_replace ("Ã¤", "&auml;", $createuser);
							$createuser = str_replace ("O„", "&Ouml;", $createuser);
							$createuser = str_replace ("Ã¶", "&ouml;", $createuser);
							$createuser = str_replace ("Ã„", "&Uuml;", $createuser);
							$createuser = str_replace ("Ã¼", "&uuml;", $createuser);
							$createuser = str_replace ("ÃŸ", "&szlig;", $createuser);
//							$createuser = htmlentities($sql->getValue('create_user'),ENT_QUOTES,'UTF-8');

							$output .= $createuser;
							if ($sql->getValue('web') != "")
								$output .= "</a>";
							$output .= " schrieb am " . date("d.m.Y H:i:s", $sql->getValue('create_date'));
							if ($sql->getValue('email') != "" && $allowreplies == 1)
								$output .= " [<a href=\"" . rex_getUrl('','', array('mode'=>'reply', 'tvsgb_id'=>$sql->getValue('id')), '&amp;') . "\">Antworten</a>]";
							$output .= "	</div>\n";
							
							$desc = $sql->getValue('description');
							$desc = str_replace ("Ã„", "&Auml;", $desc);
							$desc = str_replace ("Ã¤", "&auml;", $desc);
							$desc = str_replace ("O„", "&Ouml;", $desc);
							$desc = str_replace ("Ã¶", "&ouml;", $desc);
							$desc = str_replace ("Ã„", "&Uuml;", $desc);
							$desc = str_replace ("Ã¼", "&uuml;", $desc);
							$desc = str_replace ("ÃŸ", "&szlig;", $desc);

							$smilypath = "files/addons/tvsgb/";
							$desc = str_replace (":D", "<img src=\"" . $smilypath . "icon_biggrin.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (":)", "<img src=\"" . $smilypath . "icon_smile.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (":(", "<img src=\"" . $smilypath . "icon_sad.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (":o)", "<img src=\"" . $smilypath . "icon_surprised.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (":eek:", "<img src=\"" . $smilypath . "icon_surprised.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace ("8)", "<img src=\"" . $smilypath . "icon_cool.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (":lol:", "<img src=\"" . $smilypath . "icon_lol.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (";)", "<img src=\"" . $smilypath . "icon_wink.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (":!:", "<img src=\"" . $smilypath . "icon_exclaim.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (":?:", "<img src=\"" . $smilypath . "icon_question.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (":idea:", "<img src=\"" . $smilypath . "icon_idea.gif\" alt=\"Smile\" />", $desc);
							$desc = str_replace (":|", "<img src=\"" . $smilypath . "icon_neutral.gif\" alt=\"Smile\" />", $desc);


							$output .= "	<div class=\"gb-text\"><br />" . $desc. "</div>\n";
							$output .= "</div>";

							$sql->next();
						}
						if ($tvsgb_start > 0)
							$output .= "<div id=\"gb-links\"><a href=\"" . rex_getUrl('','', array('tvsgb_start'=>trim(($tvsgb_start - $max_entries))), '&amp;') . "\">&laquo; Vorherige Seite</a></div>";
						if ($tvsgb_start + $max_entries < $total_rows)
							$output .= "<div id=\"gb-rechts\"><a href=\"" . rex_getUrl('','', array('tvsgb_start'=>trim(($tvsgb_start + $max_entries))), '&amp;') . "\">N&auml;chste Seite &raquo;</a></div>";
					}
					else {
						$output .= "<p><br />Es wurde noch kein Eintrag dem G&auml;stebuch hinzugef&uuml;gt.</p>\n";
					}
				}
				elseif ($mode == "reply") {
					$output .= "<script type=\"text/javascript\">\n";
					$output .= "<!--\n";
					$output .= "function trim (zeichenkette) {";
					$output .= "	return zeichenkette.replace (/^\s+/, '').replace (/\s+$/, '');";
					$output .= "}";
					$output .= "function chkPost()\n";
					$output .= "{\n";
					$output .= "		if(document.gb_postentry.name.value == '')\n";
					$output .= "		{\n";
					$output .= "			alert(\"Bitte einen Namen eingeben!\");\n";
					$output .= "			document.gb_postentry.name.focus();\n";
					$output .= "			return false;\n";
					$output .= "		}\n";
					$output .= "		if(trim(document.gb_postentry.eintrag.value) == '')\n";
					$output .= "		{\n";
					$output .= "			alert(\"Bitte einen Eintrag vornehmen!\");\n";
					$output .= "			document.gb_postentry.eintrag.focus();\n";
					$output .= "			return false;\n";
					$output .= "		}\n";
					$output .= "		if(document.gb_postentry.email.value == '')\n";
					$output .= "		{\n";
					$output .= "			alert(\"Bitte eine EMail-Adresse angeben!\");\n";
					$output .= "			document.gb_postentry.email.focus();\n";
					$output .= "			return false;\n";
					$output .= "		}\n";
					$output .= "}\n";
					$output .= "//-->\n";
					$output .= "</script>\n";

					$output .= "<form action=\"" . rex_getUrl('','', array('mode'=>'post_reply','tvsgb_id'=>$id), '&amp;') . "\" name=\"gb_postentry\" method=\"post\" onSubmit=\"return chkPost()\">\n";
					$output .= "	<fieldset>\n";
					$output .= "		<legend>Antworte dem Autor dieses Eintrags</legend>\n";
					$output .= "		<label for=\"name\">Name:</label><input type=\"text\" name=\"name\" id=\"name\" value=\"\" /><br />\n";
					$output .= "		<label for=\"email\">E-Mail:</label><input type=\"text\" name=\"email\" id=\"email\" value=\"\" /><br />\n";
					$output .= "		<label for=\"eintrag\">Kommentar:</label><textarea name=\"eintrag\" id=\"eintrag\" /></textarea><br />\n";
					$output .= "		<input type=\"submit\" value=\"Abschicken\" id=\"submit\" />\n";
					$output .= "		<input type=\"button\" value=\"Abbrechen\" id=\"submit2\" onClick=\"window.location.href='" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . "';\" />\n";
					$output .= "	</fieldset>\n";
					$output .= "</form>\n";
				}
				elseif ($mode == "post_reply") {
					$sql = new rex_sql();
					$sql->setQuery("SELECT * FROM " . $art_table . " WHERE id = " . $id);
					$current_rows = $sql->getRows();
					if ($current_rows > 0 ) {
						$adminmail = ($frommail != "") ? $frommail : $infomail;
						$destmail = ($sql->getValue('email') == $highlightpw) ? $adminmail : $sql->getValue('email');
						$destsubject = "Antwort auf Deinen Eintrag vom " . date("d.m.Y H:i:s", $sql->getValue('create_date')) . " bei " . $REX['SERVERNAME'];
						$destbody =  "$name [$email]\n schrieb Dir am " . date("d.m.Y H:i:s") . ":\n$eintrag\n";
						if ($destmail != "" && $email =! "") {
							$mail = new rex_mailer();
							$mail->Sender = $email;
							$mail->From = $email;
							$mail->FromName = $name;
							$mail->AddAddress($destmail);
							$mail->Subject = utf8_decode($destsubject);
							$mail->Body = utf8_decode($destbody);
							if ($mail->Send())
								$output .= "Deine Antwort wurde verschickt, <a href=" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . ">klicke hier um zum Gästebuch zurückzukehren</a>!";
							else
								$output .= "Deine Antwort konnte scheinbar nicht erfolgreich verschickt werden, <a href=" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . ">klicke hier um zum Gästebuch zurückzukehren</a>!";
	//						if (mail($destmail, $destsubject, $destbody, $destheader, "-f$email"))
						}
						else
							$output .= "Es wurde keine Antwort versendet, da eine der Mailadressen scheinbar nicht vorhanden oder korrekt ist!";
					}
				}
			}
			else
			{
				$output = "<p>Das Gästebuch ist zu Wartungszwecken derzeit deaktiviert. Bitte versucht es doch später noch einmal.</p>\n";
			}
			//
			// Formular für neuen Eintrag...
			//
			if ($mode == "add")
			{
				$output .= "<script type=\"text/javascript\">\n";
				$output .= "<!--\n";
				$output .= "function trim (zeichenkette) {";
				$output .= "	return zeichenkette.replace (/^\s+/, '').replace (/\s+$/, '');";
				$output .= "}";
				$output .= "function chkFormular()\n";
				$output .= "{\n";
				$output .= "		if(document.gb_addentry.name.value == '')\n";
				$output .= "		{\n";
				$output .= "			alert(\"Bitte einen Namen eingeben!\");\n";
				$output .= "			document.gb_addentry.name.focus();\n";
				$output .= "			return false;\n";
				$output .= "		}\n";
				$output .= "		if(trim(document.gb_addentry.eintrag.value) == '')\n";
				$output .= "		{\n";
				$output .= "			alert(\"Bitte einen Eintrag vornehmen!\");\n";
				$output .= "			document.gb_addentry.eintrag.focus();\n";
				$output .= "			return false;\n";
				$output .= "		}\n";
				$output .= "		if(document.gb_addentry.ergebnis.value == '')\n";
				$output .= "		{\n";
				$output .= "			alert(\"Bitte bestätigen Sie Ihren Eintrag!\");\n";
				$output .= "			document.gb_addentry.ergebnis.focus();\n";
				$output .= "			return false;\n";
				$output .= "		}\n";
				$output .= "}\n";
				$output .= "function emoticon(text) {";
				$output .= "	var txtarea = document.gb_addentry.eintrag;";
				$output .= "	text = ' ' + text + ' ';";
				$output .= "	if (txtarea.createTextRange && txtarea.caretPos) {";
				$output .= "		var caretPos = txtarea.caretPos;";
				$output .= "		caretPos.text = caretPos.text.charAt(caretPos.text.length - 1) == ' ' ? caretPos.text + text + ' ' : caretPos.text + text;";
				$output .= "		txtarea.focus();";
				$output .= "	} else {";
				$output .= "		txtarea.value  += text;";
				$output .= "		txtarea.focus();";
				$output .= "	}";
				$output .= "}";
				$output .= "//-->\n";
				$output .= "</script>\n";

				$output .= "<form action=\"" . rex_getUrl('','', array('mode'=>'put'), '&amp;') . "\" name=\"gb_addentry\" method=\"post\" onSubmit=\"return chkFormular()\">\n";
				$output .= "	<fieldset>\n";
				$output .= "		<legend>Neuer Eintrag</legend>\n";
				$output .= "		<label for=\"name\">Name:</label><input type=\"text\" name=\"name\" id=\"name\" value=\"\" /><br />\n";
				$output .= "		<label for=\"email\">E-Mail:</label><input type=\"text\" name=\"email\" id=\"email\" value=\"\" /><br />\n";
				$output .= "		<label for=\"web\">Webseite:</label><input type=\"text\" name=\"web\" id=\"web\" value=\"\" /><br />\n";
				$output .= "		<label for=\"eintrag\">Kommentar:</label><textarea name=\"eintrag\" id=\"eintrag\" /></textarea><br />\n";
				if ($usesmilies == 1) {
					$output .= "<br style=\"clear:both;\">";
					$output .= "Smilies: ";
					$output .= "<a href=\"javascript:emoticon(':)')\"><img src=\"files/addons/tvsgb/icon_smile.gif\" alt=\"Smily\" title=\"Smily\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(':D')\"><img src=\"files/addons/tvsgb/icon_biggrin.gif\" alt=\"Lachen\" title=\"Lachen\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(':o)')\"><img src=\"files/addons/tvsgb/icon_surprised.gif\" alt=\"&Uuml;berrascht\" title=\"&Uuml;berrascht\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(':lol:')\"><img src=\"files/addons/tvsgb/icon_lol.gif\" alt=\"Lachen\" title=\"Lachen\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(':(')\"><img src=\"files/addons/tvsgb/icon_sad.gif\" alt=\"Traurig\" title=\"Traurig\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(':eek:')\"><img src=\"files/addons/tvsgb/icon_surprised.gif\"alt=\"&Uuml;berrascht\" title=\"&Uuml;berrascht\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon('8)')\"><img src=\"files/addons/tvsgb/icon_cool.gif\" alt=\"Cool\" title=\"Cool\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(';)')\"><img src=\"files/addons/tvsgb/icon_wink.gif\" alt=\"Winken\" title=\"Winken\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(':!:')\"><img src=\"files/addons/tvsgb/icon_exclaim.gif\" alt=\"Ausrufezeichen\" title=\"Ausrufezeichen\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(':?:')\"><img src=\"files/addons/tvsgb/icon_question.gif\" alt=\"Fragezeichen\" title=\"Fragezeichen\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(':idea:')\"><img src=\"files/addons/tvsgb/icon_idea.gif\" alt=\"Idee\" title=\"Idee\" /></a>&nbsp;";
					$output .= "<a href=\"javascript:emoticon(':|')\"><img src=\"files/addons/tvsgb/icon_neutral.gif\" alt=\"Neutral\" title=\"Neutral\" /></a>";
					$output .= "<br style=\"clear:both;\">";
				}
				$output .= "		<label for=\"ergebnis\">Zum Schutz vor SPAM bitten wir Sie,<br /> Ihren Eintrag durch Eingabe von  " . $confirmstring . "  zu best&auml;tigen:</label><input type=\"text\" name=\"ergebnis\" id=\"ergebnis\" value=\"\" /><br />\n";
				$output .= "		<input type=\"submit\" value=\"Speichern\" id=\"submit\" />\n";
				$output .= "		<input type=\"button\" value=\"Abbrechen\" id=\"submit2\" onClick=\"window.location.href='" . rex_getUrl('','', array('mode'=>'view'), '&amp;') . "';\" />\n";
				$output .= "	</fieldset>\n";
				$output .= "</form>\n";
			}

			$output .= "</div>";
			echo ($output);
		}
		else
			echo "Gästebuchausgabe mit " . $settings['max_entries'] . " Eintr&auml;gen pro Seite...";
	}
	else
		echo "TvsGB nicht verfügbar! Bitte erneut installieren!";
?>
